/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using MeshVR;using MVR.FileManagementSecure;using SimpleJSON;using System;using System.Collections;using System.Collections.Generic;using System.Linq;using System.Text;using UnityEngine;using UnityEngine.UI;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;namespace PluginIdea.Fluid{public class SSF : MVRScript{protected bool isResourcesLoaded;protected List<string> audioClipStrs;protected JSONStorableFloat audioVlolume;protected AudioSource audioSource;public static Dictionary<string, AudioClip> dic_name2Clips = new Dictionary<string, AudioClip>();public static Dictionary<string, GameObject> dic_name2Objects = new Dictionary<string, GameObject>();public static Dictionary<string, Shader> dic_name2Shaders = new Dictionary<string, Shader>();protected GameObject effectObj;private Transform RescaleObject{get{return containingAtom.reParentObject.Find("object/rescaleObject");}}protected void LoadResources(string packageName){string assetsBundlePath = $"{Utils.GetPluginPath(this)}/resources/{packageName}.assetbundle";Request request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request abffr){AudioClip[] clips = abffr.assetBundle.LoadAllAssets<AudioClip>();for (int i = 0;i < clips.Length;i++){if (!dic_name2Clips.ContainsKey(clips[i].name)){dic_name2Clips.Add(clips[i].name, clips[i]);}}GameObject[] objects = abffr.assetBundle.LoadAllAssets<GameObject>();for (int i = 0;i < objects.Length;i++){if (!dic_name2Objects.ContainsKey(objects[i].name)){dic_name2Objects.Add(objects[i].name, objects[i]);}}Shader[] shaders = abffr.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_name2Shaders.ContainsKey(shaders[i].name)){dic_name2Shaders.Add(shaders[i].name, shaders[i]);}}isResourcesLoaded = true;ReApplyInit();ReApplyUIParameter();}private bool IsPerson{get{return containingAtom.type == "Person";}}protected void CreateEffectObject(string effectObjName){var prefab = dic_name2Objects[effectObjName];effectObj = GameObject.Instantiate<GameObject>(prefab);if (IsPerson){AttachToPerson();}else{var parent = containingAtom.reParentObject.Find("object/rescaleObject");effectObj.transform.SetParent(parent);effectObj.transform.localPosition = Vector3.zero;effectObj.transform.localScale = Vector3.one;InitComponents();}if (ccs){Utils.ActiveSliderUI(forwardOffset.slider, IsPerson);Utils.ActiveSliderUI(upDownOffset.slider, IsPerson);Utils.ActiveSliderUI(leftRightOffset.slider, IsPerson);Utils.ActiveSliderUI(rotateX.slider, IsPerson);}}DAZCharacterSelector myGeometry;DAZCharacterSelector.Gender myGender = DAZCharacterSelector.Gender.None;private bool isMale = false;private void AttachToPerson(){myGeometry = containingAtom.GetStorableByID("geometry") as DAZCharacterSelector;myGender = myGeometry != null ? myGeometry.gender : DAZCharacterSelector.Gender.None;isMale = myGender == DAZCharacterSelector.Gender.Male ? true : false;Rigidbody tmpRB;if (isMale){tmpRB = containingAtom.rigidbodies.First(rb => rb.name == "Gen3");}else{tmpRB = containingAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger");}effectObj.transform.SetParent(tmpRB.transform, false);}private Transform rescaleObject;protected void InitComponents(){audioSource = Utils.GetSafeComponent<AudioSource>(effectObj);audioSource.loop = true;RescaleObject.Find("Collider").gameObject.SetActive(false);}protected void SetAudioClip(string val){if (val != "None"){if (dic_name2Clips.ContainsKey(val)){audioSource.clip = dic_name2Clips[val];audioSource.Play();}}else{audioSource.Stop();audioSource.clip = null;}}private const string packageName = "fluid";private const string effectObjName = "Fluid";private List<string> emityShpes = new List<string>{"Cone", "Sphere","Line"};private List<string> beginTypes = new List<string>{"Brook", "Fountain", "Pee", "Seminal fluid"};private List<string> attachTypes = new List<string>{"Custom", "Male", "Female"};private JSONStorableFloat A_SprayMultipleTimes;private JSONStorableString A_SprayMultipleTimesCustom;private JSONStorableBool isAutoGranulation;private JSONStorableBool isRandomSize;private JSONStorableBool isShadow;private JSONStorableFloat forwardOffset;private JSONStorableFloat upDownOffset;private JSONStorableFloat leftRightOffset;private JSONStorableFloat rotateX;private JSONStorableStringChooser emitShape;private JSONStorableStringChooser beginType;private SSF_FluidFinalSet composeFluid;private SSF_FluidRenderer fluidRenderer;private ParticleSystem particleSystem;private JSONStorableFloat pScaleXRadio;private JSONStorableFloat pScaleYRadio;private JSONStorableFloat pOffsetY;private JSONStorableFloat pBaseScaleX;private JSONStorableFloat pBaseScaleY;private JSONStorableFloat pExScale;private JSONStorableFloat maxFluidSphereAmount;private JSONStorableFloat emitRate;private JSONStorableFloat sizeMultiper;private JSONStorableFloat shapeRadius;private JSONStorableFloat shapeAngle;private JSONStorableFloat spreadDistance;private JSONStorableFloat arc;private JSONStorableFloat speed;private JSONStorableFloat gravityMul;private JSONStorableFloat maxBlurRadius;private JSONStorableFloat lifeTime;private JSONStorableFloat pointScale;private JSONStorableFloat thickness;private JSONStorableFloat softness;private JSONStorableFloat stickness;private JSONStorableFloat alpha;private JSONStorableFloat refractStrengh;private JSONStorableFloat colliderForce;private JSONStorableFloat pointScaleRadius;private JSONStorableFloat collisionScale;private JSONStorableFloat bounceFactor;private JSONStorableFloat degreeOfGranularity;private JSONStorableFloat winzoneMultiper;private JSONStorableAction startEmitAction;private JSONStorableAction stopEmitAction;private JSONStorableAction generateCubeAction;private JSONStorableColor mainColor;private JSONStorableColor specularColor;private JSONStorableFloat reflection;private JSONStorableFloat reflectionFalloff;private JSONStorableFloat shininess;private JSONStorableFloat fresnel;private ParticleSystemRenderer renderer;private  ParticleSystem.EmissionModule emissionModule;private  ParticleSystem.MainModule mainModule;private  ParticleSystem.ShapeModule shapeModule;private  ParticleSystem.CollisionModule collisionModule;public static RenderTexture m_blurredDepthTexture;public static RenderTexture m_depthTexture;public static RenderTexture m_thicknessTexture;public static RenderTexture m_foamTexture;public static RenderTexture m_blurredDepthTempTexture;public override void Init(){Location.InitTData();Utils.InitUI(CreateUIElement);LoadResources(packageName);m_blurredDepthTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);m_depthTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);m_thicknessTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);m_blurredDepthTempTexture = RenderTexture.GetTemporary(1024, 1024, 24, RenderTextureFormat.RFloat);audioClipStrs = new List<string>{"None"};UIInit();SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);}private bool ccs;private void UIInit(){ccs = Utils.IsCerPass();if (!ccs){Utils.CC2(this);}A_SprayMultipleTimes = new JSONStorableFloat("Spray X times, random duration", 0f, A_SprayMultipleTimesCallback, 0f, 20f){isStorable = false};A_SprayMultipleTimesCustom = new JSONStorableString("Spray X times, customizable", "", A_SprayMultipleTimesCustomCallback){isStorable = false};RegisterFloat(A_SprayMultipleTimes);RegisterString(A_SprayMultipleTimesCustom);startEmitAction = Utils.SetupAction(this, "StartEmit Action", StartEmit);stopEmitAction = Utils.SetupAction(this, "StopEmit Action", StopEmit);generateCubeAction = Utils.SetupAction(this, "GenerateCubeMap Action", CreateCubeMap);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PluginInfoFluid), 300, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.CommonParaSubtitle), 40, false);Utils.CreateButton(this, Location.GetStr(Location.StartEmit),StartEmit, false, ccs);Utils.CreateButton(this, Location.GetStr(Location.StopEmit), StopEmit, false, ccs);Utils.CreateSpacer(this, 10, false);Utils.CreateButton(this, Location.GetStr(Location.GrabReflectMap), ()=>{generateCubeAction.actionCallback();}, false, ccs);Utils.CreateSpacer(this, 10, false);Utils.CreateButton(this, Location.GetStr(Location.LoadPreset), LoadPreset, false, ccs);Utils.CreateButton(this, Location.GetStr(Location.SavePreset), SavePreset, false, ccs);winzoneMultiper = Utils.CreateSliderFloat(this, Location.GetStr(Location.WindZoneMul), 1, 0, 10, false, ccs);winzoneMultiper.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;ApplyWindZoneMultiper(val);};maxFluidSphereAmount = Utils.CreateSliderFloat(this, Location.GetStr(Location.MaxFluidSphereAmount), 5000, 1000, 20000, false, ccs);maxFluidSphereAmount.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.maxParticles = (int)val;};isAutoGranulation = Utils.CreateToggle(this, Location.GetStr(Location.IsAutoGranulation), true, false, ccs);isAutoGranulation.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;if (ccs)                    Utils.ActiveSliderUI(degreeOfGranularity.slider, !val);});isShadow = Utils.CreateToggle(this, Location.GetStr(Location.IsShadow), false, false, ccs);isShadow.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;renderer.enabled = val;});degreeOfGranularity = Utils.CreateSliderFloat(this, Location.GetStr(Location.DegreeOfGranularity), 1, 1, 20, false, ccs);degreeOfGranularity.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.m_blurRadius = (int)val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.MainLookSubTitle), 40, false);mainColor = Utils.CreateColor(this, Location.GetStr(Location.MainColor), new Color(0.3f, 0.3f, 0.3f), ccs);mainColor.setCallbackFunction = (h, s, v) =>{if (!isResourcesLoaded) return;composeFluid.m_color = Color.HSVToRGB(h, s, v);};specularColor = Utils.CreateColor(this, Location.GetStr(Location.SpecularColor), Color.white, ccs);specularColor.setCallbackFunction = (h, s, v) =>{if (!isResourcesLoaded) return;composeFluid.m_specular = Color.HSVToRGB(h, s, v);};alpha = Utils.CreateSliderFloat(this, Location.GetStr(Location.MainAlpha), 1, 0, 1, false, ccs);alpha.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.m_alpha = val;};shininess = Utils.CreateSliderFloat(this, Location.GetStr(Location.Shiness), 64, 0, 200, false, ccs);shininess.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.m_shininess = val;};fresnel = Utils.CreateSliderFloat(this, Location.GetStr(Location.Fresnel), 1, 0, 1, false, ccs);fresnel.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.m_fresnel = val;};refractStrengh = Utils.CreateSliderFloat(this, Location.GetStr(Location.RefractStrengh), 1f, 0, 10, false, ccs);refractStrengh.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.m_refraction = val;};reflection = Utils.CreateSliderFloat(this, Location.GetStr(Location.Reflection), 0.2f, 0, 1, false, ccs);reflection.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;composeFluid.m_reflection = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.EmitSubtitle), 40, true);sizeMultiper = Utils.CreateSliderFloat(this, Location.GetStr(Location.SizeMultiper), 1, 0.1f, 10, true, ccs);sizeMultiper.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;if (emitShape.val == "Line") shapeModule.scale = new Vector3(val, 0, 0);else shapeModule.scale = Vector3.one * val;};emitShape = Utils.CreateStringChooser(this, Location.GetStr(Location.EmitShape), emityShpes,1, true, ccs);emitShape.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;switch (val){case "Cone": shapeModule.shapeType = ParticleSystemShapeType.Cone;shapeModule.scale = Vector3.one;break;case "Sphere": shapeModule.shapeType = ParticleSystemShapeType.Sphere;shapeModule.scale = Vector3.one;break;case "Line": shapeModule.shapeType = ParticleSystemShapeType.Box;shapeModule.scale = new Vector3(sizeMultiper.val, 0, 0);break;default:                        break;}};beginType = Utils.CreateStringChooser(this, Location.GetStr(Location.BeginType), beginTypes, true, ccs);beginType.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;switch (val){case "Brook":                        emitShape.val = "Line";sizeMultiper.val = 2;emitRate.val = 1000;bounceFactor.val = 0.16f;speed.val = speed.defaultVal;shapeRadius.val = shapeRadius.defaultVal;shapeAngle.val = shapeAngle.defaultVal;pointScale.val = pointScale.defaultVal;stickness.val = stickness.defaultVal;arc.val = arc.defaultVal;mainColor.val = mainColor.defaultVal;thickness.val = thickness.defaultVal;break;case "Fountain":                        emitShape.val = emitShape.defaultVal;sizeMultiper.val = sizeMultiper.defaultVal;emitRate.val = emitRate.defaultVal;bounceFactor.val = 0.23f;speed.val = speed.defaultVal;shapeRadius.val = shapeRadius.defaultVal;shapeAngle.val = shapeAngle.defaultVal;pointScale.val = pointScale.defaultVal;stickness.val = stickness.defaultVal;arc.val = arc.defaultVal;mainColor.val = mainColor.defaultVal;thickness.val = thickness.defaultVal;break;case "Pee":                        emitShape.val = "Cone";sizeMultiper.val = sizeMultiper.defaultVal;emitRate.val = emitRate.defaultVal;bounceFactor.val = bounceFactor.defaultVal;speed.val = 2;shapeRadius.val = 0;shapeAngle.val = 0;pointScale.val = 0.02f;stickness.val = 0.39f;arc.val = 130;Color mCol = new Color(94 / 255f, 88 / 255f, 43 / 255f);mainColor.SetColor(mCol);thickness.val = thickness.defaultVal;break;case "Seminal fluid":                        emitShape.val = "Cone";sizeMultiper.val = sizeMultiper.defaultVal;emitRate.val = emitRate.defaultVal;bounceFactor.val = bounceFactor.defaultVal;speed.val = 0;shapeRadius.val = 0;shapeAngle.val = 0;pointScale.val = 0.01f;stickness.val = 0.44f;arc.val = arc.defaultVal;Color m2Col = new Color(124 / 255f, 124 / 255f, 124 / 255f);mainColor.SetColor(m2Col);thickness.val = 0.33f;break;default:                        break;}};emitRate = Utils.CreateSliderFloat(this, Location.GetStr(Location.EmitRate), 100, 1f, 2000, true, ccs);emitRate.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;emissionModule.rateOverTime = val;};lifeTime = Utils.CreateSliderFloat(this, Location.GetStr(Location.LifeTime), 5, 0f, 50, true, ccs);lifeTime.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.startLifetime = val;};shapeRadius = Utils.CreateSliderFloat(this, Location.GetStr(Location.ShapeRadius), 0.1f, 0, 2, true, ccs);shapeRadius.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.radius = val;};spreadDistance = Utils.CreateSliderFloat(this, Location.GetStr(Location.SpreadDistance), 0f, 0, 10, true, ccs);spreadDistance.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.randomPositionAmount = val;};shapeAngle = Utils.CreateSliderFloat(this, Location.GetStr(Location.ShapeAngles), 5, 0, 360, true, ccs);shapeAngle.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.angle = val;};arc = Utils.CreateSliderFloat(this, Location.GetStr(Location.ARC), 5, 0, 360, true, ccs);arc.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;shapeModule.arc = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ParticleSuntitle), 40, false);pointScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.PointScale), 0.09f, 0f, 0.2f, false, ccs);pointScale.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.m_pointScale = val;mainModule.startSizeMultiplier = val;};thickness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Thickness), 0.06f, 0f, 3f, false, ccs);thickness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.m_thickness = val;};softness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Softness), 1f, 0f, 3f, false, ccs);softness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.m_softness = val;};bounceFactor = Utils.CreateSliderFloat(this, Location.GetStr(Location.BoundFactor), 0f, 0, 1f, false, ccs);bounceFactor.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.bounce = val;};collisionScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.CollisionScale), 0f, 0, 4f, false, ccs);collisionScale.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.radiusScale = val;};maxBlurRadius = Utils.CreateSliderFloat(this, Location.GetStr(Location.MaxBlurRadius), 16, 10, 100, false, ccs);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PartcleShapeSubtitle), 40, false);isRandomSize = Utils.CreateToggle(this, Location.GetStr(Location.IsRandomSize), true, false, ccs);isRandomSize.setCallbackFunction = (val =>{if (!isResourcesLoaded) return;fluidRenderer.isRandomSize = val;});pScaleXRadio = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleScaleXRadio), 0f, 0, 2f, false, ccs);pScaleXRadio.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.hStrengh = val;};pScaleYRadio = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleScaleYRadio), 0.7f, 0, 2f, false, ccs);pScaleYRadio.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.vStrengh = val;};pOffsetY = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleOffsetY), 0.5f, -1f, 1f, false, ccs);pOffsetY.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.vOffset = val;};pBaseScaleX = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleBaseScaleXRadio), 1f, 0, 2f, false, ccs);pBaseScaleX.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.hBaseOffset = val;};pBaseScaleY = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleBaseScaleYRadio), 1f, 0, 2f, false, ccs);pBaseScaleY.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.vBaseOffset = val;};pExScale = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleScaleExtra), 0f, 0, 3f, false, ccs);pExScale.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;fluidRenderer.hExStrengh = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PhysicsParaSubtitle), 40, false);speed = Utils.CreateSliderFloat(this, Location.GetStr(Location.ParticleSpeed), 0.3f, 0f, 3, false, ccs);speed.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.startSpeed = val;};gravityMul = Utils.CreateSliderFloat(this, Location.GetStr(Location.Gravity), 1, 0, 2f, false, ccs);gravityMul.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;mainModule.gravityModifier = val;};stickness = Utils.CreateSliderFloat(this, Location.GetStr(Location.Stickness), 0.01f, 0, 1, false, ccs);stickness.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.dampen = val;};colliderForce = Utils.CreateSliderFloat(this, Location.GetStr(Location.ColliderForce), 0.1f, 0, 50, false, ccs);colliderForce.setCallbackFunction = (val) =>{if (!isResourcesLoaded) return;collisionModule.colliderForce = val;};Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PersonSubtitle), 40, true);forwardOffset = Utils.CreateSliderFloat(this, Location.GetStr(Location.ForwardOffset), 0.038f, -0.2f, 0.2f, true, ccs);forwardOffset.setCallbackFunction = FluidPositionCallback;upDownOffset = Utils.CreateSliderFloat(this, Location.GetStr(Location.UpDownOffset), 0f, -0.2f, 0.2f, true, ccs);upDownOffset.setCallbackFunction = FluidPositionCallback;leftRightOffset = Utils.CreateSliderFloat(this, Location.GetStr(Location.LeftRightOffset), 0f, -0.2f, 0.2f, true, ccs);leftRightOffset.setCallbackFunction = FluidPositionCallback;rotateX = Utils.CreateSliderFloat(this, Location.GetStr(Location.RotateX), 0f, -45f, 135f, true, ccs);rotateX.setCallbackFunction = FluidPositionCallback;}private Cubemap cubemap;private void CreateCubeMap(){cubemap = Utils.GenerateCubemap(512, containingAtom.mainController.transform.position, containingAtom.mainController.transform.rotation);composeFluid.m_cubemap = cubemap;}private const string presetSavePath = "Saves\\RealFluidSim";private const string presetEndfix = "json";private const string defaultPresetPath = "Saves\\RealFluidSim\\default.json";private void SavePreset(){FileManagerSecure.CreateDirectory(presetSavePath);var fileBrowserUI = SuperController.singleton.fileBrowserUI;fileBrowserUI.SetTitle("Save Fluid Preset");fileBrowserUI.fileRemovePrefix = null;fileBrowserUI.hideExtension = false;fileBrowserUI.keepOpen = false;fileBrowserUI.fileFormat = presetEndfix;fileBrowserUI.defaultPath = presetSavePath;fileBrowserUI.showDirs = true;fileBrowserUI.shortCuts = null;fileBrowserUI.browseVarFilesAsDirectories = false;fileBrowserUI.SetTextEntry(true);fileBrowserUI.Show((path) =>{JSONClass jc = GetSaveJc();if (string.IsNullOrEmpty(path))                    return;if (!path.EndsWith(".json"))                    path += ".json";SuperController.singleton.SaveJSON(jc, path);SuperController.LogMessage("Save Preset Success : " + path);});fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + presetEndfix;fileBrowserUI.ActivateFileNameField();}private void LoadPreset(){var shortcuts = FileManagerSecure.GetShortCutsForDirectory(presetSavePath);SuperController.singleton.GetMediaPathDialog((path) =>{Debug.Log(path);if (string.IsNullOrEmpty(path))                    return;var saveJsonNode = SuperController.singleton.LoadJSON(path);if (saveJsonNode == null) return;SuperController.LogMessage("Load Preset Success: " + path);OnPresetLoadSuccessed(saveJsonNode);}, presetEndfix, presetSavePath, false, true, false, null, false, shortcuts);}private void OnPresetLoadSuccessed(JSONNode obj){isAutoGranulation.val = bool.Parse(obj["isAutoGranulation"].Value);isRandomSize.val = bool.Parse(obj["isRandomSize"].Value);isShadow.val = bool.Parse(obj["isShadow"].Value);degreeOfGranularity.val = float.Parse(obj["degreeOfGranularity"].Value);emitRate.val = float.Parse(obj["emitRate"].Value);arc.val = float.Parse(obj["arc"].Value);shapeRadius.val = float.Parse(obj["shapeRadius"].Value);shapeAngle.val = float.Parse(obj["shapeAngle"].Value);bounceFactor.val = float.Parse(obj["bounceFactor"].Value);speed.val = float.Parse(obj["speed"].Value);gravityMul.val = float.Parse(obj["gravityMul"].Value);lifeTime.val = float.Parse(obj["lifeTime"].Value);pointScale.val = float.Parse(obj["pointScale"].Value);stickness.val = float.Parse(obj["stickness"].Value);colliderForce.val = float.Parse(obj["colliderForce"].Value);alpha.val = float.Parse(obj["alpha"].Value);winzoneMultiper.val = float.Parse(obj["winzoneMultiper"].Value);refractStrengh.val = float.Parse(obj["refractStrengh"].Value);collisionScale.val = float.Parse(obj["collisionScale"].Value);thickness.val = float.Parse(obj["thickness"].Value);reflection.val = float.Parse(obj["reflection"].Value);softness.val = float.Parse(obj["softness"].Value);int oindex = int.Parse(obj["emitShape"].Value);emitShape.val = emityShpes[oindex];fresnel.val = float.Parse(obj["fresnel"].Value);shininess.val = float.Parse(obj["shininess"].Value);maxFluidSphereAmount.val = float.Parse(obj["maxFluidSphereAmount"].Value);forwardOffset.val = float.Parse(obj["forwardOffset"].Value);upDownOffset.val = float.Parse(obj["upDownOffset"].Value);rotateX.val = float.Parse(obj["rotateX"].Value);leftRightOffset.val = float.Parse(obj["leftRightOffset"].Value);pExScale.val = float.Parse(obj["pExScale"].Value);pScaleXRadio.val = float.Parse(obj["pScaleXRadio"].Value);pScaleYRadio.val = float.Parse(obj["pScaleYRadio"].Value);pOffsetY.val = float.Parse(obj["pOffsetY"].Value);pBaseScaleX.val = float.Parse(obj["pBaseScaleX"].Value);pBaseScaleY.val = float.Parse(obj["pBaseScaleY"].Value);float mh = float.Parse(obj["MColorH"].Value);float ms = float.Parse(obj["MColorS"].Value);float mv = float.Parse(obj["MColorV"].Value);mainColor.SetVal(mh, ms, mv);float sh = float.Parse(obj["SColorH"].Value);float ss = float.Parse(obj["SColorS"].Value);float sv = float.Parse(obj["SColorV"].Value);specularColor.SetVal(sh, ss, sv);}private JSONClass GetSaveJc(){JSONClass jc = new JSONClass();jc["isAutoGranulation"] = isAutoGranulation.val.ToString();jc["degreeOfGranularity"] = degreeOfGranularity.val.ToString();jc["emitRate"] = emitRate.val.ToString();jc["arc"] = arc.val.ToString();jc["shapeRadius"] = shapeRadius.val.ToString();jc["shapeAngle"] = shapeAngle.val.ToString();jc["bounceFactor"] = bounceFactor.val.ToString();jc["speed"] = speed.val.ToString();jc["gravityMul"] = gravityMul.val.ToString();jc["lifeTime"] = lifeTime.val.ToString();jc["pointScale"] = pointScale.val.ToString("0.00");jc["stickness"] = stickness.val.ToString("0.00");jc["colliderForce"] = colliderForce.val.ToString();jc["alpha"] = alpha.val.ToString();jc["winzoneMultiper"] = winzoneMultiper.val.ToString();jc["refractStrengh"] = refractStrengh.val.ToString("0.00");jc["collisionScale"] = collisionScale.val.ToString("0.00");jc["thickness"] = thickness.val.ToString("0.00");jc["reflection"] = reflection.val.ToString();jc["softness"] = softness.val.ToString("0.00");jc["emitShape"] = (emityShpes.IndexOf(emitShape.val)).ToString();jc["fresnel"] = fresnel.val.ToString();jc["shininess"] = shininess.val.ToString();jc["maxFluidSphereAmount"] = maxFluidSphereAmount.val.ToString();jc["forwardOffset"] = forwardOffset.val.ToString();jc["upDownOffset"] = upDownOffset.val.ToString();jc["rotateX"] = rotateX.val.ToString();jc["leftRightOffset"] = leftRightOffset.val.ToString();jc["isRandomSize"] = isRandomSize.val.ToString();jc["pExScale"] = pExScale.val.ToString();jc["pScaleXRadio"] = pScaleXRadio.val.ToString();jc["pScaleYRadio"] = pScaleYRadio.val.ToString();jc["pOffsetY"] = pOffsetY.val.ToString();jc["pBaseScaleX"] = pBaseScaleX.val.ToString();jc["pBaseScaleY"] = pBaseScaleY.val.ToString();jc["isShadow"] = isShadow.val.ToString();jc["MColorH"] = mainColor.val.H.ToString("0.00");jc["MColorS"] = mainColor.val.S.ToString("0.00");jc["MColorV"] = mainColor.val.V.ToString("0.00");jc["SColorH"] = specularColor.val.H.ToString("0.00");jc["SColorS"] = specularColor.val.S.ToString("0.00");jc["SColorV"] = specularColor.val.V.ToString("0.00");return jc;}protected void FluidPositionCallback(float val){if (!isResourcesLoaded) return;effectObj.transform.localPosition = new Vector3(leftRightOffset.val, upDownOffset.val, forwardOffset.val);effectObj.transform.localRotation = Quaternion.Euler(rotateX.val, 0f, 0f);}private void StopEmit(){particleSystem.Stop();}private void StartEmit(){particleSystem.Play();}private void Update(){if (isAutoGranulation.val && fluidRenderer != null){float dis = Vector3.Distance(Utils.CenterCameraTrans.position, transform.position);fluidRenderer.m_blurRadius = (int)Mathf.Lerp(10, 1, dis / (maxBlurRadius.val * pointScale.val * 10));}}protected void ReApplyInit(){CreateEffectObject(effectObjName);ParticleSystem[] pss = effectObj.GetComponentsInChildren<ParticleSystem>();if (pss.Length > 0){for (int i = 0;i < pss.Length;i++){var ex = pss[i].externalForces;ex.enabled = true;}}particleSystem = effectObj.GetComponent<ParticleSystem>();emissionModule = particleSystem.emission;mainModule = particleSystem.main;shapeModule = particleSystem.shape;collisionModule = particleSystem.collision;StopEmit();renderer = particleSystem.GetComponent<ParticleSystemRenderer>();renderer.enabled = false;int controlLayer = 1 << LayerMask.NameToLayer("ControlColliders");collisionModule.collidesWith = ~controlLayer;collisionModule.maxCollisionShapes = 2000;composeFluid = Utils.GetSafeComponent<SSF_FluidFinalSet>(Utils.CenterCamera.gameObject);composeFluid.shader = dic_name2Shaders["ScreenSpaceFluids/SSF_FluidFinalSet"];fluidRenderer = Utils.GetSafeComponent<SSF_FluidRenderer>(effectObj);}protected void ReApplyUIParameter(){isAutoGranulation.setCallbackFunction(isAutoGranulation.val);degreeOfGranularity.setCallbackFunction(degreeOfGranularity.val);emitRate.setCallbackFunction(emitRate.val);arc.setCallbackFunction(arc.val);shapeRadius.setCallbackFunction(shapeRadius.val);shapeAngle.setCallbackFunction(shapeAngle.val);bounceFactor.setCallbackFunction(bounceFactor.val);speed.setCallbackFunction(speed.val);gravityMul.setCallbackFunction(gravityMul.val);lifeTime.setCallbackFunction(lifeTime.val);pointScale.setCallbackFunction(pointScale.val);mainColor.setCallbackFunction(mainColor.val.H, mainColor.val.S, mainColor.val.V);specularColor.setCallbackFunction(specularColor.val.H, specularColor.val.S, specularColor.val.V);stickness.setCallbackFunction(stickness.val);colliderForce.setCallbackFunction(colliderForce.val);alpha.setCallbackFunction(alpha.val);winzoneMultiper.setCallbackFunction(winzoneMultiper.val);refractStrengh.setCallbackFunction(refractStrengh.val);collisionScale.setCallbackFunction(collisionScale.val);thickness.setCallbackFunction(thickness.val);reflection.setCallbackFunction(reflection.val);softness.setCallbackFunction(softness.val);emitShape.setCallbackFunction(emitShape.val);fresnel.setCallbackFunction(fresnel.val);shininess.setCallbackFunction(shininess.val);maxFluidSphereAmount.setCallbackFunction(maxFluidSphereAmount.val);forwardOffset.setCallbackFunction(forwardOffset.val);upDownOffset.setCallbackFunction(upDownOffset.val);rotateX.setCallbackFunction(rotateX.val);leftRightOffset.setCallbackFunction(leftRightOffset.val);isRandomSize.setCallbackFunction(isRandomSize.val);pExScale.setCallbackFunction(pExScale.val);pScaleXRadio.setCallbackFunction(pScaleXRadio.val);pScaleYRadio.setCallbackFunction(pScaleYRadio.val);pOffsetY.setCallbackFunction(pOffsetY.val);pBaseScaleX.setCallbackFunction(pBaseScaleX.val);pBaseScaleY.setCallbackFunction(pBaseScaleY.val);isShadow.setCallbackFunction(isShadow.val);CreateCubeMap();}protected void ApplyWindZoneMultiper(float val){ParticleSystem[] pss = effectObj.GetComponentsInChildren<ParticleSystem>();if (pss.Length > 0){for (int i = 0;i < pss.Length;i++){var ex = pss[i].externalForces;ex.multiplier = val;}}}private void A_SprayMultipleTimesCallback(float numtimes){DoSprayMultipleTimesRandomDuration((int)Mathf.Floor(numtimes));A_SprayMultipleTimes.val = 0f;}private void A_SprayMultipleTimesCustomCallback(string customText){DoSprayMultipleTimesCustom(customText);A_SprayMultipleTimesCustom.val = "";}private void DoSprayMultipleTimesRandomDuration(int numtimes){if (isSprayActive == false){StartCoroutine(SprayMultipleTimesRandomDuration(numtimes));}}private void DoSprayMultipleTimesCustom(string customText){if (isSprayActive == false){StartCoroutine(SprayMultipleTimesCustom(customText));}}private bool isSprayActive = false;private IEnumerator SprayMultipleTimesRandomDuration(int numtimes){isSprayActive = true;int sprayLoops = 0;while (sprayLoops < numtimes){particleSystem.Play();float sprayTime = UnityEngine.Random.Range(0.1f, 1f);yield return new WaitForSeconds(sprayTime);particleSystem.Stop();float pauseTime = UnityEngine.Random.Range(0.2f, 0.4f);yield return new WaitForSeconds(pauseTime);sprayLoops++;}isSprayActive = false;}private IEnumerator SprayMultipleTimesCustom(string customText){isSprayActive = true;string[] seq = customText.Split(';');if (seq.Length > 0){foreach (string seqElement in seq){string[] sprayElem = seqElement.Split(',');if (sprayElem.Length == 2){particleSystem.Play();yield return new WaitForSeconds(float.Parse(sprayElem[0]));particleSystem.Stop();yield return new WaitForSeconds(float.Parse(sprayElem[1]));}}}isSprayActive = false;}public void OnBindingsListRequested(List<object> bindings){}private void OnDestroy(){ReleaseRT();Destroy(composeFluid);Destroy(fluidRenderer);Destroy(effectObj);Utils.DestroyUI();SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);}private static void ReleaseRT(){RenderTexture.ReleaseTemporary(m_blurredDepthTexture);RenderTexture.ReleaseTemporary(m_depthTexture);RenderTexture.ReleaseTemporary(m_thicknessTexture);RenderTexture.ReleaseTemporary(m_blurredDepthTempTexture);}}}